/*
*
*		cu-Prolog (Constraint Unification Prolog)
*   Copyright: Institute for New Generation Computer Technology,Japan 1989
*
*               <<<<   varset.h    >>>>
*
*		cf. main.c
*		set global vars
* 88/6/10
* 88/7/28 FUNCFIRST
* 88/8/10 timer 
* 89.6.27 CAHC
* 90.7.1 ver3.10
*/

long CONSTRAINT_HANDLING_TIME = 0L;

#ifndef MAC
FILE *lfp;
int tty;
char	logfile[32] = "no";	/* no log  */
#endif

char STANDARD_INPUT[8] = "stdin";
char STANDARD_OUTPUT[8] = "stdout";
FILE *fp,*wfp; /* read file pointer, write fp, log fp */
FILE *READ_FILE = stdin;
FILE *WRITE_FILE = stdout;
FILE *OPEN_FILES[FOPEN_MAX];
char OPEN_FILE_NAMES[FOPEN_MAX][FILENAME_MAX];
char OPEN_FILE_MODE[FOPEN_MAX];
char SEEING_FILE[FILENAME_MAX];
char TELLING_FILE[FILENAME_MAX];
int cbuf;		/* character buffer */
struct ustack *utop;
int ECHO_BACK = 0;
int Handle_Undefined = FALSE; /* fail return */
int Print_Depth = 32;
int line_counter = 0;

int tflag;   /* trace flag  0-> off, 1-> on 2->step trace on */
int sflag;   /* solution mode flag  1->all solutions, 0->one solution */
int simplify_flag; /* simplifier  is effective when TRUE */
int CTmode;			/* trace mode 0,1,2 */
int refute_node_count = -1;	/* refute node counter in c.t. */

/* Classification of Characters */
#define BL  001  /* blank */
#define UC  002  /* Upper Character */
#define LC  003  /* Lower Character */
#define UL  004  /* Undef Line */
#define N   005  /* Numeric */
#define SG  006  /* sign, +- */
#define SP  007  /* special character */
#define Q   010  /* quote */
#define CT  011  /* Cut */
#define CM  012  /* comment character */
#define BR  013  /* Brackets, Commas */
#define CO  014  /* Constraint Marker */

int char_type[128] = {
/* 00, 01, 02, 03, 04, 05, 06, 07, 10, 11, 12, 13, 14, 15, 16, 17 */
   BL, BL, BL, BL, BL, BL, BL, BL, BL, BL, BL, BL, BL, BL, BL, BL, 
/* 20, 21, 22, 23, 24, 25, 26, 27, 30, 31, 32, 33, 34, 35, 36, 37 */
   BL, BL, BL, BL, BL, BL, BL, BL, BL, BL, BL, BL, BL, BL, BL, BL, 
/* sp,  !,  "   #   $   %   &   '   (   )   *   +   ,   -   .   / */
   BL, CT,  Q, SP, SP, CM, SP,  Q, BR, BR, SP, SG, BR, SG, SP, SP,
/*  0   1   2   3   4   5   6   7   8   9   :   ;   <   =   >   ? */
    N,  N,  N,  N,  N,  N,  N,  N,  N,  N, SP, CO, SP, SP, SP,  SP,
/*  @   A   B   C   D   E   F   G   H   I   J   K   L   M   N   O */
   SP, UC, UC, UC, UC, UC, UC, UC, UC, UC, UC, UC, UC, UC, UC, UC,
/*  P   Q   R   S   T   U   V   W   X   Y   Z   [   \   ]   ^   _ */
   UC, UC, UC, UC, UC, UC, UC, UC, UC, UC, UC, BR, SP, BR, SP, UL,
/*  `   a   b   c   d   e   f   g   h   i   j   k   l   m   n   o */
   SP, LC, LC, LC, LC, LC, LC, LC, LC, LC, LC, LC, LC, LC, LC, LC,
/*  p   q   r   s   t   u   v   w   x   y   z   {   |   }   ~  del */
   LC, LC, LC, LC, LC, LC, LC, LC, LC, LC, LC, BR, BR, BR, SP, BL };

char nbuf[NAME_MAX];	/* name buffer */
int  v_number = 0;		/* temporary var number */
int  p_number = 0;
int qv_number = 0;
struct term *v_list = NULL;		/* temporary var list */
struct term *pv_list = NULL;
struct func *f_list = NULL;	 /* new function list entry */
/* struct node *n_last = NULL;	*/ /* node list */
struct operator *o_list = NULL;
struct itrace *newf_list = NULL;	/* new function definition  */
struct itrace *newfsave = NULL;
struct itrace *newflist_save = NULL;
struct pst_item *psttable;

int Def_Modified = 0;		/* def modified flag */

int Refcount;	/* maximum of refute counter */
int MODULARMAX;	/* maximum number of Variables in Transformation */
int timer_switch = TRUE;	/* clock timer switch (ON/OFF) */
int M_SOLVED;

struct node  *Last_BT, *Last_SKIP;

char	genname[8] = "c",	/* generate function name c0,c1,... */
        Anonymous_VarName[4]="_";
int tokentype, reread;
int GENSYM = 0;
char user_prompt[NAME_MAX];
int is_user_input = FALSE;

long int *SHEAPTOP, *Heap_Max, *HEAPTOP;
long int *CHEAPTOP, *Cheap_Max;
struct pair *ESPTOP, *Esp_Max;
char  *NHEAPTOP;
struct ustack  *STACKTOP, *Stack_Max;

struct cset *DEF_list;		/* sets of new predicate derivation clauses */
struct cset *CSTR_list;		/* sets of non-modular clauses */
struct cset *INITDEF_list;		/* sets of non-modular clauses */
struct cset *MODULAR_list;
struct clause *REST_literals, *CONST_literals, *CONST_PST_literals; /* used in split, attach */
struct up_log  *UP_pstlog;	/* used in up_init and search_pst_log */
struct clause *PSTLISTS;
int EVAL_PST_FLAG;

#include <setjmp.h>
jmp_buf reset;		/* error recovery */
jmp_buf unbreak_reset;		/* trace --- unbreak */
jmp_buf trans_fail; /* transformation failure */
jmp_buf split_fail;
jmp_buf read_eof;

/* for Macintosh */
#ifdef MAC
int font_size = 12, font_type =1, font_item = 0;
int refNum = 0;
WindowRecord	wRecord;
WindowPtr	myWindow;
TEHandle		TEH;
int		linesInFolder, theVRefNum;
Rect		dragRect = {0, 0, 1024,1024};
ControlHandle	vScroll;
Cursor		editCursor, waitCursor;
Str255 		 theFileName;
MenuHandle		myMenus[8];
/* DialogPtr 	myDialogs[6]; */
Handle		OKHandle, CancelHandle, AllHandle, OtherHandle,
	InputTextHandle, GoOnHandle, QuitHandle, TraceOffHandle,
	NormalTraceHandle, ManualHandle, AncestorsHandle, BreakHandle,
	LeapHandle, SkipHandle, FailReturnHandle, ShowHandle,
	UnfoldFoldHandle, ResetHandle;

int lfp = 0;
int cursor_position;
int KEYIN = TRUE;
int KEYOUT = TRUE;

char wbuf[NAME_MAX], ibuf[NAME_MAX];
char *ibufpt;
#endif
